#
# spec file for package uasm
#
# Copyright (c) 2025 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


Name:           uasm
Version:        2.57r
Release:        1.3
Summary:        MASM-compatible assembler based on JWasm
License:        Watcom-1.0
URL:            http://www.terraspace.co.uk/%{name}.html
Source:         https://github.com/Terraspace/%{name}/archive/refs/tags/v%{version}.tar.gz
Patch0:         fix-error-return-type.patch
BuildRequires:  glibc-devel

%description
MASM-compatible assembler based on JWasm

%prep
%autosetup -n UASM-%{version} -p1

%build
# Workaround for boo#1225948
%global optflags %{optflags} -fpermissive
%make_build -f Makefile-Linux-GCC-64.mak CFLAGS="%{optflags}"

%install
mkdir -p %{buildroot}%{_bindir}
install GccUnixR/%{name} -t %{buildroot}%{_bindir}

%files
%doc Readme.txt
%doc History.txt
%license License.txt
%{_bindir}/%{name}

%changelog
* Sun Jan  5 2025 Antonio Teixeira <antonio.teixeira@suse.com>
- Update to 2.57:
  * Added aam/aad imm8 missing instruction variant.
  * Added corrections for constant too large warnings and included >64bit size immediate errors.
  * Corrected a conflict between local and struct having the same name.
  * Updated the encoding of xchg eax,eax to not just be a NOP in 64bit code as a side effect is
    clearing the top half of RAX.
  * Reduced unnecessary REX prefixes in PROC prologue.
  * Cleaned up makefile names
  * Fixed a general failure on empty unions.
  * Applied typedef ptr fix in legacy codeview symbolic debugging info.
  * Noted string literal usage in manual.
  * Fixed a stack balancing regression leading to an umatched add/sub rsp,8 pair forLinux 64bit.
  * Prevented vmovd/vmovq from accepting ymm or zmm registes.
  * Prevent OR rax,64bit immediate and other instructions that aren't MOV.
  * Based on a patch to original Jwasm which may have entered an infinite loop if a structured
    variable wasn't defined (yet), but a member name matched a local name.
  * Included Vortex Def2Lib utility in the distribution with Import Definitions kindly supplied
    from MASM32.
    Can be run via MakeLib.bat or
    def2lib *.def
    def2lib ntvdm.def -e
* Mon Jul 15 2024 Martin Jambor <mjambor@suse.com>
- Added -fpermissive to %%{optflags} so that GCC 14 does not
  treat various C99 violations present in the source as errors
  by default. [boo#1225948]
* Tue Nov 29 2022 Danilo Spinella <danilo.spinella@suse.com>
- Initial packaging of uasm version 2.56.2
